<template>
    <div>
        <label
            v-if="!hideLabel"
            class="block text-sm font-medium capitalize"
            :class="{
                'border-red-500': errors && errors.length,
                'text-red-500': errors && errors.length,
                'font-black': boldLabel,
            }"
        >
            {{ label || name }}
        </label>
        <div class="mt-1 relative rounded-sm shadow-sm cursor-pointer">
            <label class="cursor-pointer">
                <input
                    :id="id"
                    ref="filePicker"
                    type="file"
                    :name="name"
                    :placeholder="placeholder"
                    :multiple="multiple"
                    class="focus:ring-indigo-500 focus:border-indigo-500 block w-full sm:text-sm border rounded-md p-2 text-black hidden"
                    :accept="accept"
                    :class="{
                        'pl-7': prependIcon,
                        'pr-7': modelValue,
                        'border-gray-300': !errors,
                        'border-red-500': errors && errors.length,
                        'text-red-500': errors && errors.length,
                    }"
                    @change="fileChanged"
                />
                <div
                    class="form-control"
                    :class="{
                        'pl-7': prependIcon,
                        'pr-7': modelValue,
                        'border-gray-300': !errors,
                        'border-red-500': errors && errors.length,
                        'text-red-500': errors && errors.length,
                        'disabled': disabled || readonly,
                    }"
                >
                    {{ selectText }}
                </div>
            </label>

            <div
                v-if="selectedFile"
                class="absolute inset-y-0 right-0 pr-3 flex items-center cursor-pointer text-black"
                @click="clearFile"
            >
                <span
                    :class="{
                        'text-red-500': errors && errors.length,
                    }"
                >
                    <svg xmlns="http://www.w3.org/2000/svg" class="h-6 w-6" fill="none" viewBox="0 0 24 24" stroke="currentColor">
                      <path stroke-linecap="round" stroke-linejoin="round" stroke-width="2" d="M6 18L18 6M6 6l12 12" />
                    </svg>
                </span>
            </div>
        </div>
        <div
            v-if="note && Array.isArray(note)"
        >
            <div
                v-for="(n, i) in note"
                :key="`note-${i}`"
            >
                <div class="font-light font-sm">{{ n }}</div>
            </div>
        </div>
        <div
            v-else-if="note && !Array.isArray(note)"
        >
            <div class="font-light font-sm">{{ note }}</div>
        </div>
        <div
            v-if="errors && errors.length"
        >
            <div
                v-for="(err, i) in errors"
                :key="i"
            >
                <div class="font-light font-sm text-red-500">{{ err }}</div>
            </div>
        </div>
    </div>
</template>

<script setup>
import {computed, ref, watch} from 'vue';
import {useI18n} from 'vue-i18n';
const {t} = useI18n();
const props = defineProps({
    id: {
        required: false,
        type: [String, Number],
        default: null,
    },
    name: {
        required: true,
        type: [String, Number],
    },
    label: {
        required: false,
        type: [String, Number],
        default: null,
    },
    boldLabel: {
        required: false,
        type: Boolean,
        default: false,
    },
    hideLabel: {
        required: false,
        type: Boolean,
        default: false,
    },
    accept: {
        required: false,
        type: [String],
        default: '*/*',
    },
    placeholder: {
        required: false,
        type: [String, Number, Boolean],
        default: '',
    },
    note: {
        required: false,
        type: [String, Number, Array],
        default: null,
    },
    modelValue: {
        required: false,
        type: [String, Number, Boolean],
        default: '',
    },
    errors: {
        required: false,
        type: Array,
        default: () => [],
    },
    prependIcon: {
        required: false,
        type: String,
        default: null,
    },
    multiple: {
        required: false,
        type: Boolean,
        default: false,
    },
    disabled: {
        required: false,
        type: Boolean,
        default: false,
    },
    readonly: {
        required: false,
        type: Boolean,
        default: false,
    }
});
let data = ref(props.modelValue);
const filePicker = ref();
const selectedFile = ref(0);
const emit = defineEmits(['update:modelValue']);

const fileChanged = event => {
    try {
        if (props.multiple) {
            if (event.target.files) {
                selectedFile.value = event.target.files.length;
                emit('update:modelValue', event.target.files);
            } else {
                selectedFile.value = 0;
                emit('update:modelValue', '');
            }
        } else {
            if (event.target.files[0]) {
                selectedFile.value = 1;
                emit('update:modelValue', event.target.files[0]);
            } else {
                selectedFile.value = 0;
                emit('update:modelValue', '');
            }
        }
    } catch (e) {
        selectedFile.value = 0;
        emit('update:modelValue', '');
    }
}

const clearFile = () => {
    filePicker.value.value = '';
    selectedFile.value = 0;
    emit('update:modelValue', '');
}

const selectText = computed(() => {
    if (selectedFile.value) {
        if (props.multiple) {
            return t('selected_x_file', {x: selectedFile.value});
        } else if (props.modelValue.name) {
            return props.modelValue.name;
        }
    }

    if (props.placeholder) {
        return props.placeholder;
    } else {
        return t('click_to_select_file');
    }
})

watch(data, (newValue) => {
    emit('update:modelValue', newValue);
})
</script>
